org.apache.jmeter.util

## Class JSR223TestElement

- java.lang.Object
- - org.apache.jmeter.testelement.AbstractTestElement
  - - org.apache.jmeter.util.ScriptingTestElement
    - - org.apache.jmeter.util.JSR223TestElement

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, Searchable, TestElement, TestStateListener
  Direct Known Subclasses:
    JSR223Assertion, JSR223Listener, JSR223PostProcessor, JSR223PreProcessor, JSR223Sampler, JSR223Timer

      public abstract class JSR223TestElement
      extends ScriptingTestElement
      implements java.io.Serializable, TestStateListener

  Base class for JSR223 Test elements
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.apache.jmeter.util.ScriptingTestElement

      `DEFAULT_SCRIPT_LANGUAGE, scriptLanguage`

    - ### Fields inherited from interface org.apache.jmeter.testelement.TestElement

      `COMMENTS, ENABLED, GUI_CLASS, NAME, TEST_CLASS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JSR223TestElement()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `compile()`
    `java.lang.String` | `getCacheKey()`
    `static javax.script.ScriptEngineManager` | `getInstance()`
    `protected javax.script.ScriptEngine` | `getScriptEngine()`
    `java.lang.String` | `getScriptLanguage()`
    `protected void` | `populateBindings(javax.script.Bindings bindings)` Populate variables to be passed to scripts
    `protected java.lang.Object` | `processFileOrScript(javax.script.ScriptEngine scriptEngine, javax.script.Bindings pBindings)` This method will run inline script or file script with special behaviour for file script: - If ScriptEngine implements Compilable script will be compiled and cached - If not if will be run
    `void` | `setCacheKey(java.lang.String cacheKey)`
    `void` | `setScriptLanguage(java.lang.String s)`
    `void` | `testEnded()` Called once for all threads after the end of a test.
    `void` | `testEnded(java.lang.String host)` Called once for all threads after the end of a test.
    `void` | `testStarted()` Called just before the start of the test from the main engine thread.
    `void` | `testStarted(java.lang.String host)` Called just before the start of the test from the main engine thread.

    - ### Methods inherited from class org.apache.jmeter.util.ScriptingTestElement

      `getFilename, getParameters, getScript, isStopCondition, setFilename, setParameters, setScript`

    - ### Methods inherited from class org.apache.jmeter.testelement.AbstractTestElement

      `addPropertiesValues, addProperty, addProperty, addTestElement, canRemove, clear, clearTemporary, clearTestElementChildren, clone, emptyTemporary, equals, getComment, getName, getProperty, getPropertyAsBoolean, getPropertyAsBoolean, getPropertyAsDouble, getPropertyAsFloat, getPropertyAsInt, getPropertyAsInt, getPropertyAsLong, getPropertyAsLong, getPropertyAsString, getPropertyAsString, getSearchableTokens, getThreadContext, getThreadName, hashCode, isEnabled, isRunningVersion, isTemporary, logProperties, mergeIn, propertyIterator, recoverRunningVersion, removeProperty, setComment, setEnabled, setName, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setRunningVersion, setTemporary, setThreadContext, setThreadName, traverse, traverseCollection, traverseMap, traverseProperty`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.jmeter.testelement.TestElement

      `removed`

- - ### Constructor Detail

    - #### JSR223TestElement

          public JSR223TestElement()

  - ### Method Detail

    - #### getInstance

          public static javax.script.ScriptEngineManager getInstance()

      Returns:
        ScriptEngineManager singleton

    - #### getScriptEngine

          protected javax.script.ScriptEngine getScriptEngine()
                                                       throws javax.script.ScriptException

      Returns:
        `ScriptEngine` for language defaulting to groovy if language is not set
      Throws:
        `javax.script.ScriptException` - when no `ScriptEngine` could be found

    - #### populateBindings

          protected void populateBindings(javax.script.Bindings bindings)

      Populate variables to be passed to scripts
      Parameters:
        `bindings` - Bindings

    - #### processFileOrScript

          protected java.lang.Object processFileOrScript(javax.script.ScriptEngine scriptEngine,
                                                         javax.script.Bindings pBindings)
                                                  throws java.io.IOException,
                                                         javax.script.ScriptException

      This method will run inline script or file script with special behaviour for file script: - If ScriptEngine implements Compilable script will be compiled and cached - If not if will be run
      Parameters:
        `scriptEngine` - ScriptEngine
        `pBindings` - `Bindings` might be null
      Returns:
        Object returned by script
      Throws:
        `java.io.IOException` - when reading the script fails
        `javax.script.ScriptException` - when compiling or evaluation of the script fails

    - #### compile

          public boolean compile()
                          throws javax.script.ScriptException,
                                 java.io.IOException

      Returns:
        boolean true if element is not compilable or if compilation succeeds
      Throws:
        `java.io.IOException` - if script is missing
        `javax.script.ScriptException` - if compilation fails

    - #### getCacheKey

          public java.lang.String getCacheKey()

      Returns:
        the cacheKey

    - #### setCacheKey

          public void setCacheKey(java.lang.String cacheKey)

      Parameters:
        `cacheKey` - the cacheKey to set

    - #### testStarted

          public void testStarted()

      Description copied from interface: `TestStateListener`

      Called just before the start of the test from the main engine thread. This is before the test elements are cloned. Note that not all the test variables will have been set up at this point.

      N.B. testStarted() and testEnded() are called from different threads.

      Specified by:
        `testStarted` in interface `TestStateListener`
      See Also:
        `TestStateListener.testStarted()`

    - #### testStarted

          public void testStarted(java.lang.String host)

      Description copied from interface: `TestStateListener`

      Called just before the start of the test from the main engine thread. This is before the test elements are cloned. Note that not all the test variables will have been set up at this point.

      N.B. testStarted() and testEnded() are called from different threads.

      Specified by:
        `testStarted` in interface `TestStateListener`
      Parameters:
        `host` - name of host
      See Also:
        `TestStateListener.testStarted(java.lang.String)`

    - #### testEnded

          public void testEnded()

      Description copied from interface: `TestStateListener`

      Called once for all threads after the end of a test. This will use the same element instances as at the start of the test.

      N.B. testStarted() and testEnded() are called from different threads.

      Specified by:
        `testEnded` in interface `TestStateListener`
      See Also:
        `TestStateListener.testEnded()`

    - #### testEnded

          public void testEnded(java.lang.String host)

      Description copied from interface: `TestStateListener`

      Called once for all threads after the end of a test. This will use the same element instances as at the start of the test.

      N.B. testStarted() and testEnded() are called from different threads.

      Specified by:
        `testEnded` in interface `TestStateListener`
      Parameters:
        `host` - name of host
      See Also:
        `TestStateListener.testEnded(java.lang.String)`

    - #### getScriptLanguage

          public java.lang.String getScriptLanguage()

    - #### setScriptLanguage

          public void setScriptLanguage(java.lang.String s)

Copyright © 1998-2019 Apache Software Foundation. All Rights Reserved.